const uuid = require('node-uuid');
const fs = require('fs');
const request = require('request');

download = function(url) {
  return new Promise((resolve,reject)=>{
    console.log("download...."+url);
    let dest = null;
    let req = request.get(url);
    req.on('response', function(res) {
      var contentType, file, match, suffix;
      if (res.statusCode !== 200) {
          return reject("error: " + res.statusCode);
      }
      contentType = res.headers['content-type'];
      match = contentType.match(/image\/(.*);/);
      suffix = (match != null ? match[1] : void 0) ? '.' + match[1] : '.jpeg';
      dest = '/tmp/' + uuid.v4() + suffix;
      file = fs.createWriteStream(dest);
      file.on('finish', function() {
         console.log("finish ...........")
         file.close(function(err) {
         resolve(dest);
        });
      });
      file.on('error', function(err) {
        fs.unlink(dest);
        reject(err);
      });
      req.pipe(file);
    });
    return req.on('error', function(err) {
      if (dest) {
        fs.unlink(dest);
      }
      reject(err);
    });
  })
};

module.exports = download


